#!/usr/bin/python
# -*- coding: utf-8 -*-

from axioma.gui import *
from axioma.gui import extension
from axioma import *
from axioma.app import *
from axioma.core import *
from PyQt5.QtCore import QCoreApplication
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *
from PyQt5.QtCore import *
from PyQt5.QtWebKitWidgets import *
from PyQt5.QtWebKit import *

class MainWindow(QMainWindow):
	def __init__(self):
		super(MainWindow, self).__init__()
		self.view = QWebView(self)
		self.view.page().settings().setAttribute(QWebSettings.DeveloperExtrasEnabled,True)
		f = QFileInfo("python_plugins\open_browser\index.html")
		#print("file:///" + f.absoluteFilePath())
		self.view.load(QUrl("file:///" + f.absoluteFilePath()))
		self.view.loadFinished.connect(self.adjustLocation)
		self.view.loadFinished.connect(self.finishLoading)
		self.locationEdit = QLineEdit(self)
		self.locationEdit.setSizePolicy(QSizePolicy.Expanding, self.locationEdit.sizePolicy().verticalPolicy())
		self.locationEdit.returnPressed.connect(self.changeLocation)
		toolBar = self.addToolBar("Navigation")
		toolBar.addAction(self.view.pageAction(QWebPage.Reload))
		toolBar.addAction(self.view.pageAction(QWebPage.Stop))
		toolBar.addWidget(self.locationEdit)
		self.setCentralWidget(self.view)

	def adjustLocation(self):
		self.locationEdit.setText(self.view.url().toString())

	def changeLocation(self):
		url = QUrl.fromUserInput(self.locationEdit.text())
		self.view.load(url)
		self.view.setFocus()

	def finishLoading(self):
		browser.view.page().mainFrame().addToJavaScriptWindowObject("extern",axioma.app.mainWindow);

global browser
browser = MainWindow()

class ExampleActionExtension(axioma.gui.NativeActionExtension):
	def __init__(self, action_id, ribbon_action_info, parent=None):
		super().__init__(action_id, ribbon_action_info, parent)
		self.mainwindow = self.createDependencyGetter(axioma.app.MainWindow)

	def createAction_impl(self, parent):
		action = PyQt5.QtWidgets.QAction(parent)
		action.setText("Пример действия")
		action.setIcon(QIcon(":/icons/32px/run.png"))
		action.triggered.connect(self.slot);
		return action

	def slot(self):
		browser.show()

def createMyExtensions():
	ribbonExt = axioma.gui.extension.RibbonExtension()
	ribbonExt.addTab("ExamplePluginTab", QCoreApplication.translate("ru.axioma-gis.pluginexample","Пример модуля"))
	ribbonExt.addGroup("ExamplePluginTab","ExampleGroupId", QCoreApplication.translate("ru.axioma-gis.pluginexample","Команды модуля"))
	ribbonExt.addCategory("ExamplePluginCategory", QCoreApplication.translate("ru.axioma-gis.pluginexample","Пример модуля"))
	ribbonExt.addAction("ExampleActionId", "ExamplePluginTab", "ExampleGroupId",rowSpan=2, columnSpan=2)
	ribbonExt.addAction("ExampleToolId", "ExamplePluginTab", "ExampleGroupId")
	actionExt = ExampleActionExtension("ExampleActionId", axioma.gui.RibbonActionInfo("ExamplePluginCategory", "", ""))
	return [ribbonExt, actionExt]
